#include <allegro.h>
//#include "demo.h"
DATAFILE *datos;
BITMAP *fondo, *intermedio;
volatile int tiempo, fps, rps, cont_fps, cont_rps;
int driver=GFX_DIRECTX_WIN,ancho=640,alto=480;



extern int menu();
extern void juego();

void reloj(void){
  tiempo++;
}
END_OF_FUNCTION(reloj);

void almacena_fps(void){
  fps=cont_fps;
  cont_fps=0;
  rps=cont_rps;
  cont_rps=0;
}
END_OF_FUNCTION(almacena_fps);

DATAFILE * leemedatos(const char * cadena){
   char buf[256],buf2[256];
   get_executable_name(buf, sizeof(buf));   //Carga de datos
   replace_filename(buf2,buf,cadena,sizeof(buf2));
   return(load_datafile(buf2));
}

void ponpantalla(void){
   destroy_bitmap(intermedio);
   destroy_bitmap(fondo);
   set_gfx_mode(driver,ancho,alto,0,0); //y una resolucin 800x600
   intermedio=create_bitmap(640,480);
   fondo=create_bitmap(640,480);
}

INLINE void borra(int x, int y, int an, int al){
  blit(fondo,intermedio,x,y,x,y,an,al);
}

INLINE void pinta(int x, int y, const RLE_SPRITE *imagen){
  //masked_blit(imagen,intermedio,0,0,x,y,imagen->w,imagen->h);
  draw_rle_sprite(intermedio,imagen,x,y);
}
INLINE void refresca(void){
  blit(intermedio,screen,0,0,0,0,ancho,alto);
}

void inicializa(void){
   allegro_init();
   install_keyboard();
   install_timer();
   LOCK_FUNCTION(reloj);
   LOCK_FUNCTION(fps);
   LOCK_FUNCTION(cont_fps);
   LOCK_FUNCTION(rps);
   LOCK_FUNCTION(cont_rps);
   LOCK_VARIABLE(tiempo);
   LOCK_VARIABLE(almacena_fps);
   tiempo=0;
   install_int_ex(reloj,BPS_TO_TIMER(50));
   install_int_ex(almacena_fps,BPS_TO_TIMER(1));
   install_mouse();
   set_color_depth(16); //Por ejemplo, para usar 16 bits de color
   intermedio=create_bitmap(640,480);
   fondo=create_bitmap(640,480);
   ponpantalla();
   clear(screen); //Borra la pantalla
   datos=leemedatos("qa32.dat");
   //set_palette(datos[GAME_PAL].dat);
}

void finaliza (void){
   destroy_bitmap(intermedio);
   destroy_bitmap(fondo);
   allegro_exit();
}

int main(int argc, char* argv[]){
  inicializa();
  while(menu()){
    juego();
    }
  finaliza();
  return (0);
}
END_OF_MAIN();
