#include <stdlib.h>
#include <stdio.h>
//#include <string.h>
#include "allegro.h"
#include "cola.h"
#include "rutini.h"

const int MaxTolEsc=3; //Mximo nmero de escenas que se pueden quedar sin pintar

typedef struct movil{
  int x,y,vx,vy;
  COLADOR *anterior;
}movil;

int numsucios,modo,tama,numima,fijos[13*15];


BITMAP *pantalla,*imagen,*estatico,*dib_fondo,**piezas;
PALETTE pal;
volatile int escenas,ips_cuent,ips;


void test(void){
  int escenas_prep,i,j,tot_movil,incremento=0;
  movil *lista,*prov;
  char datos[80];
  BITMAP *texto_temp;

  texto_temp=create_bitmap(300,10);
  clear(estatico);
  //exit(1);
  for (i=0;i<estatico->w;i+=dib_fondo->w)
    for (j=0;j<estatico->h;j+=dib_fondo->h)
      blit(dib_fondo,estatico,0,0,i,j,dib_fondo->w,dib_fondo->h);
  escenas=0;
  escenas_prep=0;
  ips_cuent=0;
  lista=malloc(sizeof(struct movil));
  if (lista==NULL) {
     exit(1);
  }
  tot_movil=1;
  lista[0].vx=random()%48-24;
  lista[0].vy=random()%48-24;
  lista[0].x=random()%(SCREEN_W<<3);
  lista[0].y=random()%(SCREEN_H<<3);
  blit(estatico,pantalla,0,0,0,0,estatico->w,estatico->h);
  //clear(screen);
  blit(imagen,pantalla,0,0,lista[0].x>>3,lista[0].y>>3,imagen->w,imagen->h);
  blit(pantalla,screen,0,0,0,0,SCREEN_W,SCREEN_H);
  while (!key[KEY_ESC]){
    if (key[KEY_A]) incremento=1;
    if (key[KEY_Q]) incremento=-1;
    if (key[KEY_P]) incremento=0;
    if (escenas_prep==0)
      for(i=0;i<tot_movil;++i)
        enbcola(estatico,pantalla,lista[i].x>>3,lista[i].y>>3,lista[i].x>>3,
          lista[i].y>>3,imagen->w,imagen->h);
    else
      for(i=0;i<tot_movil;++i) desencola(lista[i].anterior);
    for(i=0;i<tot_movil;++i){
      lista[i].x+=lista[i].vx;
      if(lista[i].x>(SCREEN_W<<3)) lista[i].x-=(SCREEN_W+32)<<3;else
        if(lista[i].x<-32<<3) lista[i].x+=(SCREEN_W+32)<<3;
      lista[i].y+=lista[i].vy;
      if(lista[i].y>(SCREEN_H<<3)) lista[i].y-=(SCREEN_H+32)<<3;else
        if(lista[i].y<-32<<3) lista[i].y+=(SCREEN_H+32)<<3;
      lista[i].anterior=encola(imagen,pantalla,0,0,lista[i].x>>3,lista[i].y>>3,imagen->w,
        imagen->h);
    }
    if (ips!=0){
      if (incremento>0){
        //Importante: introduce nuevos elementos despus de pintar los dems
        ++tot_movil;
        prov=realloc(lista,tot_movil*sizeof(struct movil));
        if (prov==NULL) {
          --tot_movil;
        }else {
          lista=prov;
          i=tot_movil-1;
          lista[i].vx=random()%48-24;
          lista[i].vy=random()%48-24;
          lista[i].x=random()%(SCREEN_W<<3);
          lista[i].y=random()%(SCREEN_H<<3);
          lista[i].anterior=encola(imagen,pantalla,0,0,lista[i].x>>3,lista[i].y>>3,imagen->w,
            imagen->h);
        }
      }else if ((incremento<0)&&(tot_movil>1)){
        --tot_movil;
        lista=realloc(lista,tot_movil*sizeof(struct movil));
      }
      //Repinta la zona esttica
      for (i=0;i<estatico->w;i+=dib_fondo->w)
        for (j=0;j<estatico->h;j+=dib_fondo->h)
          blit(dib_fondo,estatico,0,0,i,j,dib_fondo->w,dib_fondo->h);
      sprintf(datos,"Imagenes por segundo: %i",ips);
      clear(texto_temp);
      textout(texto_temp,font,datos,0,0,255);
      masked_blit(texto_temp,estatico,0,0,5,5,text_length(font,datos),
        text_height(font));
      encola(estatico,pantalla,5,5,5,5,text_length(font,datos),
        text_height(font));
      sprintf(datos,"Moviles activos: %i",tot_movil);
      clear(texto_temp);
      textout(texto_temp,font,datos,0,0,255);
      masked_blit(texto_temp,estatico,0,0,325,5,text_length(font,datos),
        text_height(font));
      encola(estatico,pantalla,325,5,325,5,text_length(font,datos),
        text_height(font));
      //En realidad, el texto esttico slo debe introducirse en caso
      // de saber que no se pasa por encima, para que se vea
      ips=0;
    }
    ++escenas_prep;
    while(escenas<escenas_prep);
    if ((escenas==escenas_prep) || (escenas>=MaxTolEsc)){
      escenas=0;
      escenas_prep=0;
      //vsync();
      descarga();
      ips_cuent++;
    }
  }
  free(lista);
  destroy_bitmap(texto_temp);
}

void juego(void){
  int i,j,escenas_prep,jug[3],xdeci,ydeci,xreal,yreal,mov,vel_y;
  int cont_rota=0,excepcion=0;
  BITMAP *trip;
  COLADOR *anterior;

  prepara_nivel();
  clear(estatico);
      for (i=0;i<estatico->w;i+=dib_fondo->w)
        for (j=0;j<estatico->h;j+=dib_fondo->h)
          blit(dib_fondo,estatico,0,0,i,j,dib_fondo->w,dib_fondo->h);
  clear(pantalla);
  for(i=0;i<15;++i){
    masked_blit(piezas[i],estatico,0,0,15*tama,tama*i,tama,tama);
  }
  for(i=15;i<30;++i){
    masked_blit(piezas[i],estatico,0,0,17*tama,tama*(i-15),tama,tama);
  }
  for(i=30;i<36;++i){
    masked_blit(piezas[i],estatico,0,0,19*tama,tama*(i-30),tama,tama);
  }
  blit(estatico,pantalla,0,0,0,0,SCREEN_W,SCREEN_H);
  blit(estatico,screen,0,0,0,0,SCREEN_W,SCREEN_H);
  for (i=0;i<3;++i) jug[i]=rand()%17;
  trip=tripleta(jug);
  escenas_prep=0;
  escenas=0;
  mov=0;
  for(i=0;i<13*15;++i)fijos[i]=-1;
  vel_y=64*tama;
  xdeci=16*tama;
  ydeci=(17*tama)<<10;
  while (!key[KEY_ESC]){
    if(escenas_prep==0){
      xreal=(xdeci>>1)+tama;
      yreal=SCREEN_H-tama-(ydeci>>10);
      enbcola(estatico,pantalla,xreal,yreal,xreal,yreal,tama,3*tama);
    }else desencola(anterior);
    if ((xdeci>>1)%tama==0) mov=0;
    if (cont_rota>0) cont_rota--; else
      if (key[KEY_UP]){
        cont_rota=10;
        destroy_bitmap(trip);
        i=jug[0];jug[0]=jug[2];jug[2]=jug[1];jug[1]=i;
        trip=tripleta(jug);
      }
    if (key[KEY_RIGHT]) if((xdeci<24*tama)&&(excepcion==0)) mov=tama>>1;
    if ((key[KEY_LEFT])&&(excepcion==0)) {
      mov=0;
      if(xdeci>0) mov=-(tama>>1);
      }
    if((xdeci>>1)%tama==0){
      if (mov>0) if (fijos[((y_deci>>10)/tama-2)*13+((xdeci>>1)/tama+1)]>=0)
        mov=0;
      if (mov<0) if (fijos[((y_deci>>10)/tama-2)*13+((xdeci>>1)/tama-1)]>=0)
        mov=0;
    }
    xdeci+=mov;
    ydeci-=vel_y;
    if((ydeci>>10)/tama<2){
      //Hemos chocado con el fondo
    }else
      if(13*(fijos[(ydeci>>10)/tama-2)+(xdeci>>1)/tama]>=0){
        //Hemos chocado con una pieza
      }
    if((xdeci>>1)%tama==0){
      if((ydeci>>10)/tama>=2)
        if(13*(fijos[(ydeci>>10)/tama-2)+(xdeci>>1)/tama+1]>=0){
          //Hemos chocado con una pieza de la columna del lado
        }
    }
    if((excepcion==0)
    xreal=(xdeci>>1)+tama;
    yreal=SCREEN_H-tama-(ydeci>>10);
    anterior=encola(trip,pantalla,0,0,xreal,yreal,tama,3*tama);
    ++escenas_prep;
    while(escenas<escenas_prep);
    if((escenas==escenas_prep)||(escenas>=MaxTolEsc)){
      escenas=0;
      escenas_prep=0;
      descarga();
    }
  }
  readkey();
}

int main(int argc, char *argv[]){
   int i,modo;
   COLADOR *prueba,*bucle;

  modo=2;
  for (i=1;i<argc;i++){
    if (stricmp(argv[i],"-r4")==0) modo=4;
    if (stricmp(argv[i],"-r3")==0) modo=3;
    if (stricmp(argv[i],"-r2")==0) modo=2;
    if (stricmp(argv[i],"-r1")==0) modo=1;
    if (stricmp(argv[i],"-r0")==0) modo=0;
  }

  if (start(modo)!=0) return(1);
  //test();
  juego();
  return (0);
}
